Index: /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/TaskController.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/TaskController.cs	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/TaskController.cs	(revision 12878)
@@ -0,0 +1,178 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.IO;
+using System.Linq;
+using System.Net;
+using System.Net.Http;
+using System.Net.Http.Headers;
+using System.Web.Http;
+using HeuristicLab.Services.Access;
+using HeuristicLab.Services.Hive;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
+using DA = HeuristicLab.Services.Hive.DataAccess;
+using DT = HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi {
+  [Authorize]
+  public class TaskController : ApiController {
+    private IPersistenceManager PersistenceManager {
+      get { return ServiceLocator.Instance.PersistenceManager; }
+    }
+
+    private IUserManager UserManager {
+      get { return ServiceLocator.Instance.UserManager; }
+    }
+
+    private IRoleVerifier RoleVerifier {
+      get { return ServiceLocator.Instance.RoleVerifier; }
+    }
+
+    [HttpPost]
+    public DT.TaskPage GetTasksByJobId(Guid id, int page, int size, IEnumerable<string> states) {
+      var pm = PersistenceManager;
+      var dimJobDao = pm.DimJobDao;
+      var dimClientDao = pm.DimClientDao;
+      var factTaskDao = pm.FactTaskDao;
+
+      DA.DimJob job = pm.UseTransaction(() => dimJobDao.GetById(id));
+      if (job == null) {
+        throw new ArgumentException("invalid job id");
+      }
+      if (job.UserId != UserManager.CurrentUserId) {
+        RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator);
+      }
+
+      return pm.UseTransaction(() => {
+        var tasks = factTaskDao.GetByJobId(id).Where(x => states.Contains(x.TaskState.ToString()));
+        return new DT.TaskPage {
+          TotalTasks = tasks.Count(),
+          Tasks = (from factTask in tasks
+                   join dimJob in dimJobDao.GetAll() on factTask.JobId equals dimJob.JobId
+                   join dimClient in dimClientDao.GetAll() on factTask.LastClientId equals
+                     dimClient.Id into taskClientJoin
+                   from a in taskClientJoin.DefaultIfEmpty()
+                   let startTime = factTask.StartTime ?? DateTime.Now
+                   let endTime = factTask.EndTime ?? DateTime.Now
+                   select new DT.Task {
+                     Id = factTask.TaskId,
+                     JobId = factTask.JobId,
+                     JobName = dimJob.JobName,
+                     TotalTime = (long)(endTime - startTime).TotalSeconds,
+                     CalculatingTime = factTask.CalculatingTime,
+                     WaitingTime = factTask.WaitingTime,
+                     TransferTime = factTask.TransferTime,
+                     InitialWaitingTime = factTask.InitialWaitingTime,
+                     NumCalculationRuns = factTask.NumCalculationRuns,
+                     NumRetries = factTask.NumRetries,
+                     CoresRequired = factTask.CoresRequired,
+                     MemoryRequired = factTask.MemoryRequired,
+                     Priority = factTask.Priority,
+                     State = factTask.TaskState.ToString(),
+                     LastClientId = factTask.LastClientId,
+                     LastClientName = a != null ? a.Name : string.Empty,
+                     UserId = dimJob.UserId,
+                     UserName = dimJob.UserName,
+                     StartTime = factTask.StartTime,
+                     EndTime = factTask.EndTime,
+                     Exception = factTask.Exception
+                   })
+            .Skip((page - 1) * size)
+            .Take(size)
+            .ToList()
+        };
+      });
+    }
+
+    [HttpPost]
+    public DT.TaskPage GetTasksByClientId(Guid id, int page, int size, IEnumerable<string> states, Guid userId = default(Guid)) {
+      bool isAdministrator = User.IsInRole(HiveRoles.Administrator);
+      var pm = PersistenceManager;
+      var dimJobDao = pm.DimJobDao;
+      var dimClientDao = pm.DimClientDao;
+      var factTaskDao = pm.FactTaskDao;
+      return pm.UseTransaction(() => {
+        var tasks = factTaskDao.GetByClientId(id).Where(x => states.Contains(x.TaskState.ToString()));
+        if (userId != Guid.Empty) {
+          tasks = tasks.Where(x => x.DimJob.UserId == userId);
+        }
+        return new DT.TaskPage {
+          TotalTasks = tasks.Count(),
+          Tasks = (from factTask in tasks
+                   join dimJob in dimJobDao.GetAll() on factTask.JobId equals dimJob.JobId
+                   join dimClient in dimClientDao.GetAll() on factTask.LastClientId equals
+                     dimClient.Id into taskClientJoin
+                   from a in taskClientJoin.DefaultIfEmpty()
+                   let startTime = factTask.StartTime ?? DateTime.Now
+                   let endTime = factTask.EndTime ?? DateTime.Now
+                   select new DT.Task {
+                     Id = isAdministrator ? factTask.TaskId : default(Guid),
+                     JobId = isAdministrator ? factTask.JobId : default(Guid),
+                     JobName = isAdministrator ? dimJob.JobName : string.Empty,
+                     TotalTime = (long)(endTime - startTime).TotalSeconds,
+                     CalculatingTime = factTask.CalculatingTime,
+                     WaitingTime = factTask.WaitingTime,
+                     TransferTime = factTask.TransferTime,
+                     InitialWaitingTime = factTask.InitialWaitingTime,
+                     NumCalculationRuns = factTask.NumCalculationRuns,
+                     NumRetries = factTask.NumRetries,
+                     CoresRequired = factTask.CoresRequired,
+                     MemoryRequired = factTask.MemoryRequired,
+                     Priority = factTask.Priority,
+                     State = factTask.TaskState.ToString(),
+                     LastClientId = factTask.LastClientId,
+                     LastClientName = a != null ? a.Name : string.Empty,
+                     UserId = isAdministrator ? dimJob.UserId : default(Guid),
+                     UserName = isAdministrator ? dimJob.UserName : string.Empty,
+                     StartTime = factTask.StartTime,
+                     EndTime = factTask.EndTime,
+                     Exception = isAdministrator ? factTask.Exception : string.Empty
+                   })
+                .OrderByDescending(x => x.EndTime ?? DateTime.MaxValue)
+                .Skip((page - 1) * size)
+                .Take(size)
+                .ToList()
+        };
+      });
+    }
+
+    public HttpResponseMessage GetTaskDataById(Guid id) {
+      var pm = PersistenceManager;
+      var taskDataDao = pm.TaskDataDao;
+      return pm.UseTransaction(() => {
+        var taskData = taskDataDao.GetById(id);
+        if (taskData == null)
+          return new HttpResponseMessage(HttpStatusCode.NotFound);
+        HttpResponseMessage result = new HttpResponseMessage(HttpStatusCode.OK);
+        var stream = new MemoryStream(taskData.Data);
+        result.Content = new StreamContent(stream);
+        result.Content.Headers.ContentType = new MediaTypeHeaderValue("application/octet-stream");
+        result.Content.Headers.ContentDisposition =
+          new ContentDispositionHeaderValue("attachment") {
+            FileName = string.Format("{0}.hl", id)
+          };
+        return result;
+      });
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/UserController.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/UserController.cs	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/UserController.cs	(revision 12878)
@@ -0,0 +1,71 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Web.Http;
+using HeuristicLab.Services.Hive;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
+using DT = HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi {
+
+  [Authorize(Roles = HiveRoles.Administrator)]
+  public class UserController : ApiController {
+    private IPersistenceManager PersistenceManager {
+      get { return ServiceLocator.Instance.PersistenceManager; }
+    }
+
+    public IEnumerable<DT.User> GetUsers() {
+      var pm = PersistenceManager;
+      var dimUserDao = pm.DimUserDao;
+      return pm.UseTransaction(() => {
+        return dimUserDao.GetAll().Select(x => new DT.User {
+          Id = x.UserId,
+          Name = x.Name
+        }).ToList();
+      });
+    }
+
+    public DT.UserDetails GetUser(Guid id) {
+      var pm = PersistenceManager;
+      var dimUserDao = pm.DimUserDao;
+      var factTaskDao = pm.FactTaskDao;
+      return pm.UseTransaction(() => {
+        var user = dimUserDao.GetById(id);
+        if (user != null) {
+          return new DT.UserDetails {
+            Id = user.UserId,
+            Name = user.Name,
+            TasksStates = factTaskDao.GetByUserId(id)
+                          .GroupBy(x => x.TaskState)
+                          .Select(x => new DT.TaskStateCount {
+                            State = x.Key.ToString(),
+                            Count = x.Count()
+                          }).ToList()
+          };
+        }
+        return null;
+      });
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/clients.cshtml
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/clients.cshtml	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/clients.cshtml	(revision 12878)
@@ -0,0 +1,123 @@
+﻿@using HeuristicLab.Services.Access.DataTransfer
+@using HeuristicLab.Services.Hive
+<header class="view-header">
+    <ul class="nav nav-list nav-list-topbar pull-left">
+        <li>
+            <a ng-href="#/statistics/jobs">Jobs</a>
+        </li>
+        @if (Request.IsAuthenticated && User.IsInRole(HiveRoles.Administrator)) {
+            <li>
+                <a ng-href="#/statistics/users">Users</a>
+            </li>
+        }
+        <li class="active">
+            <a ng-href="#/statistics/clients">Clients</a>
+        </li>
+        <li>
+            <a ng-href="#/statistics/groups">Groups</a>
+        </li>
+        @if (Request.IsAuthenticated && User.IsInRole(HiveRoles.Administrator)) {
+            <li>
+                <a ng-href="#/statistics/exceptions">Exceptions</a>
+            </li>
+        }
+    </ul>
+</header>
+
+<div class="default-view-container">
+    <div class="row">
+        <div class="col-lg-12">
+            <div class="panel panel-default">
+                <div class="panel-heading">
+                    <h3 class="panel-title">Current Clients</h3>
+                </div>
+                <div class="panel-body">
+                    <table class="table table-hover table-condensed">
+                        <thead>
+                        <tr>
+                            <th>#</th>
+                            <th>Client Name</th>
+                            <th>Group Name</th>
+                            <th>Cores</th>
+                            <th>Cpu Utilization</th>
+                            <th>Memory</th>
+                            <th>State</th>
+                            <th></th>
+                        </tr>
+                        </thead>
+                        <tr ng-repeat="client in clientPage.Clients">
+                            <td>{{($index + 1)+((curClientsPage-1)*(clientsPageSize))}}</td>
+                            <td>{{client.Name}}</td>
+                            <td>
+                                <a ng-show="client.GroupName" ng-href="#/statistics/groups/{{client.GroupId}}">{{client.GroupName}}</a>
+                                <span ng-hide="client.GroupName">No Group</span>
+                            </td>
+                            <td>{{client.UsedCores}} / {{client.TotalCores}}</td>
+                            <td>{{client.CpuUtilization | number: 2}} %</td>
+                            <td>{{client.UsedMemory | kbToGB}} / {{client.TotalMemory | kbToGB}} GB</td>
+                            <td>{{client.State}}</td>
+                            <td>
+                                <a ng-href="#/statistics/clients/{{client.Id}}">Details</a>
+                            </td>
+                        </tr>
+                        <tr ng-hide="clientPage.Clients.length">
+                            <td colspan="7" class="text-center">No clients found!</td>
+                        </tr>
+                    </table>
+                    <div class="row text-center" ng-show="clientPage.TotalClients > clientPage.Clients.length">
+                        <pagination max-size="10" total-items="clientPage.TotalClients" ng-model="curClientsPage" ng-change="changeClientsPage()" items-per-page="clientsPageSize"
+                                    boundary-links="true" rotate="false" num-pages="numPages"></pagination>
+                    </div>
+                </div>
+            </div>
+        </div>
+    </div>
+
+    <div class="row">
+        <div class="col-lg-12">
+            <div class="panel panel-default">
+                <div class="panel-heading">
+                    <h3 class="panel-title">Expired Clients</h3>
+                </div>
+                <div class="panel-body">
+                    <table class="table table-hover table-condensed">
+                        <thead>
+                            <tr>
+                                <th>#</th>
+                                <th>Client Name</th>
+                                <th>Group Name</th>
+                                <th>Cores</th>
+                                <th>Cpu Utilization</th>
+                                <th>Memory</th>
+                                <th>State</th>
+                                <th></th>
+                            </tr>
+                        </thead>
+                        <tr ng-repeat="client in expiredClientPage.Clients">
+                            <td>{{($index + 1)+((curExpiredClientsPage-1)*(expiredClientsPageSize))}}</td>
+                            <td>{{client.Name}}</td>
+                            <td>
+                                <span ng-show="client.GroupName">{{client.GroupName}}</span>
+                                <span ng-hide="client.GroupName">No Group</span>
+                            </td>
+                            <td>{{client.UsedCores}} / {{client.TotalCores}}</td>
+                            <td>{{client.CpuUtilization | number: 2}} %</td>
+                            <td>{{client.UsedMemory | kbToGB}} / {{client.TotalMemory | kbToGB}} GB</td>
+                            <td>{{client.State}}</td>
+                            <td>
+                                <a ng-href="#/statistics/clients/{{client.Id}}">Details</a>
+                            </td>
+                        </tr>
+                        <tr ng-hide="expiredClientPage.Clients.length">
+                            <td colspan="7" class="text-center">No expired clients found!</td>
+                        </tr>
+                    </table>
+                    <div class="row text-center" ng-show="expiredClientPage.TotalClients > expiredClientPage.Clients.length">
+                        <pagination max-size="10" total-items="expiredClientPage.TotalClients" ng-model="curExpiredClientsPage" ng-change="changeExpiredClientsPage()" items-per-page="expiredClientsPageSize"
+                                    boundary-links="true" rotate="false" num-pages="numPages"></pagination>
+                    </div>
+                </div>
+            </div>
+        </div>
+    </div>
+</div>
Index: /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/clientsCtrl.js
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/clientsCtrl.js	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/clientsCtrl.js	(revision 12878)
@@ -0,0 +1,50 @@
+﻿(function () {
+    var module = appStatisticsPlugin.getAngularModule();
+    module.controller('app.statistics.clientsCtrl',
+        ['$scope', '$interval', 'app.statistics.clientService',
+        function ($scope, $interval, clientService) {
+            $scope.interval = defaultPageUpdateInterval;
+            $scope.curClientsPage = 1;
+            $scope.clientsPageSize = 20;
+            $scope.curExpiredClientsPage = 1;
+            $scope.expiredClientsPageSize = 20;
+
+            var getClients = function () {
+                clientService.getClients({ page: $scope.curClientsPage, size: $scope.clientsPageSize, expired: false },
+                    function (clientPage) {
+                        $scope.clientPage = clientPage;
+                    }
+                );
+            };
+
+            var getExpiredClients = function() {
+                clientService.getClients({ page: $scope.curExpiredClientsPage, size: $scope.expiredClientsPageSize, expired: true },
+                    function (clientPage) {
+                        $scope.expiredClientPage = clientPage;
+                    }
+                );
+            };
+
+            var update = function () {
+                getClients();
+                getExpiredClients();
+            };
+
+            $scope.changeClientsPage = function () {
+                update();
+            };
+
+            $scope.changeExpiredClientsPage = function () {
+                update();
+            };
+
+            $scope.updateInterval = $interval(update, $scope.interval);
+            var cancelInterval = $scope.$on('$locationChangeSuccess', function () {
+                $interval.cancel($scope.updateInterval);
+                cancelInterval();
+            });
+            update(); // init page
+
+        }]
+    );
+})();
